; Shifter - serial input module for BLINKENmini, LittleLights and BlinkenLeds
; main loop
; version 0.2 date 2006-02-28
; Copyright (C) 2005-2006 Stefan Schuermans <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
; a BlinkenArea project - http://www.blinkenarea.org/



; main loop
;  - used stack depth: 2
MAIN:
        wdr                                     ; watchdog reset
        clr     STEP                            ; output step counter to first output step
        clr     OUT_PTR_FLAG                    ; initialize output buffer pointers
        rcall   OUT_FLIP
        rcall   TIMEOUT_START                   ; start timeout movie
        clr     SNES_FLAG                       ; no new SNES key data available
        clr     RECV_STEP                       ; start receiving with a new message
        clr     TRANS_STEP                      ; start transmitting with first byte
        sei                                     ; turn on interrupts

MAIN_LOOP:

; watchdog reset
        wdr

; receive serial data
        rcall   RECV

; transmit serial data
.IF CONF_SNES
        rcall   TRANS
.ENDIF

; timeout processing
        rcall   TIMEOUT_TASK

; bottom of main loop
        rjmp     MAIN_LOOP

